package com.ejie.ab79.service.preguntasRespuestas;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.ejie.ab79.dao.preguntasRespuestas.OpcionesPreProDao;
import com.ejie.ab79.model.REST.servicioWeb.Opcion;
import com.ejie.ab79.model.preguntasRespuestas.OpcionesPrePro;
import com.ejie.ab79.model.preguntasRespuestas.PreguntasProtocolo;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableResponseDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * OpcionesPreProServiceImpl  
 *  
 */

@Service(value = "opcionesPreProService")
public class OpcionesPreProServiceImpl implements OpcionesPreProService {

	@Autowired
	private OpcionesPreProDao opcionesPreProDao;

	/**
	 * Inserts a single row in the OpcionesPrePro table.
	 *
	 * @param opcionesPrePro OpcionesPrePro
	 * @return OpcionesPrePro
	 */
	@Transactional(rollbackFor = Throwable.class)
	public OpcionesPrePro add(OpcionesPrePro opcionesPrePro) {
		return this.opcionesPreProDao.add(opcionesPrePro);
	}

	/**
	 * Updates a single row in the OpcionesPrePro table.
	 *
	 * @param opcionesPrePro OpcionesPrePro
	 * @return OpcionesPrePro
	 */
	@Transactional(rollbackFor = Throwable.class)
	public OpcionesPrePro update(OpcionesPrePro opcionesPrePro) {
		return this.opcionesPreProDao.update(opcionesPrePro);
	 }

	/**
	 * Finds a single row in the OpcionesPrePro table.
	 *
	 * @param opcionesPrePro OpcionesPrePro
	 * @return OpcionesPrePro
	 */
	public OpcionesPrePro find(OpcionesPrePro opcionesPrePro) {
		return (OpcionesPrePro) this.opcionesPreProDao.find(opcionesPrePro);
	}
	
	/**
	 * Deletes a single row in the OpcionesPrePro table.
	 *
	 * @param opcionesPrePro OpcionesPrePro
	 */
	@Transactional(rollbackFor = Throwable.class)
	public void remove(OpcionesPrePro opcionesPrePro) {
		this.opcionesPreProDao.remove(opcionesPrePro);
	}

	/**
	 * Finds a list of rows in the OpcionesPrePro table.
	 *
	 * @param opcionesPrePro OpcionesPrePro
	 * @param tableRequestDto TableRequestDto
	 * @return List<OpcionesPrePro>
	 */
	public List<OpcionesPrePro> findAll(OpcionesPrePro opcionesPrePro, TableRequestDto tableRequestDto){
		return (List<OpcionesPrePro>) this.opcionesPreProDao.findAll(opcionesPrePro, tableRequestDto);
	}
    
	/**
	 * Finds rows in the OpcionesPrePro table using like.
	 *
	 * @param opcionesPrePro OpcionesPrePro
	 * @param tableRequestDto TableRequestDto
     * @param startsWith Boolean	 
	 * @return List<OpcionesPrePro>
	 */
	public List<OpcionesPrePro> findAllLike(OpcionesPrePro opcionesPrePro, TableRequestDto tableRequestDto, Boolean startsWith){
		return (List<OpcionesPrePro>) this.opcionesPreProDao.findAllLike(opcionesPrePro, tableRequestDto, startsWith);
	}

	@Override
	public List<Opcion> findOpcionesREST(Integer idPreguntaProtocolo) {
		return (List<Opcion>) this.opcionesPreProDao.findOpcionesREST(idPreguntaProtocolo);
	}

	/*
	 * OPERACIONES RUP_TABLE
	 */
	 
	/**
	 * Removes rows from the OpcionesPrePro table.
	 *
	 * @param filterOpcionesPrePro OpcionesPrePro
	 * @param tableRequestDto TableRequestDto
	 * @param startsWith Boolean
	 */	
	public void removeMultiple(OpcionesPrePro filterOpcionesPrePro, TableRequestDto tableRequestDto,  Boolean startsWith){
		this.opcionesPreProDao.removeMultiple(filterOpcionesPrePro, tableRequestDto, startsWith);
	}
        
	/**
	 * Filter method in the OpcionesPrePro table.
	 *
	 * @param filterOpcionesPrePro OpcionesPrePro
	 * @param tableRequestDto TableRequestDto
	 * @param startsWith Boolean
	 * @return TableResponseDto<OpcionesPrePro>
	 */	
	public TableResponseDto< OpcionesPrePro> filter(OpcionesPrePro filterOpcionesPrePro, TableRequestDto tableRequestDto,  Boolean startsWith){
		List<OpcionesPrePro> listaOpcionesPrePro =  this.opcionesPreProDao.findAllLike(filterOpcionesPrePro, tableRequestDto, false);
		Long recordNum =  this.opcionesPreProDao.findAllLikeCount(filterOpcionesPrePro != null ? filterOpcionesPrePro: new OpcionesPrePro (),false);
		
		TableResponseDto<OpcionesPrePro> usuarioDto = new TableResponseDto<OpcionesPrePro>(tableRequestDto, recordNum, listaOpcionesPrePro);
		
		if (tableRequestDto.getMultiselection().getSelectedIds()!=null){
			List< TableRowDto< OpcionesPrePro>> reorderSelection = this.opcionesPreProDao.reorderSelection(filterOpcionesPrePro, tableRequestDto, startsWith);
			usuarioDto.setReorderedSelection(reorderSelection);
			usuarioDto.addAdditionalParam("reorderedSelection", reorderSelection);
			usuarioDto.addAdditionalParam("selectedAll", tableRequestDto.getMultiselection().getSelectedAll());
		}
		if (tableRequestDto.getSeeker().getSelectedIds()!=null){
			tableRequestDto.setMultiselection(tableRequestDto.getSeeker());
			List< TableRowDto< OpcionesPrePro>> reorderSeeker = this.opcionesPreProDao.reorderSelection(filterOpcionesPrePro, tableRequestDto, startsWith);
			usuarioDto.setReorderedSeeker(reorderSeeker);
			usuarioDto.addAdditionalParam("reorderedSeeker", reorderSeeker);
		}
		return usuarioDto;   
	}
    /**
	 * Searches rows in the OpcionesPrePro table.
	 *
	 * @param filterOpcionesPrePro OpcionesPrePro
	 * @param searchOpcionesPrePro OpcionesPrePro
	 * @param tableRequestDto TableRequestDto
	 * @param startsWith Boolean
	 * @return List<TableRowDto<OpcionesPrePro>>
	 */	
    public List< TableRowDto< OpcionesPrePro>> search(OpcionesPrePro filterOpcionesPrePro, OpcionesPrePro searchOpcionesPrePro, TableRequestDto tableRequestDto, Boolean startsWith){
		return this.opcionesPreProDao.search(filterOpcionesPrePro, searchOpcionesPrePro, tableRequestDto, startsWith);
	}
    
    /**
	 * Reorder the selection made in OpcionesPrePro table.
	 *
	 * @param filterOpcionesPrePro OpcionesPrePro
	 * @param tableRequestDto TableRequestDto
	 * @param startsWith Boolean
	 * @return Object
	 */	
    public Object reorderSelection(OpcionesPrePro filterOpcionesPrePro, TableRequestDto tableRequestDto, Boolean startsWith){
		return this.opcionesPreProDao.reorderSelection(filterOpcionesPrePro, tableRequestDto, startsWith);
	}
    
    /*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */
	 
	/**
	 * Finder method in the hierarchical the OpcionesPrePro table.
	 *
	 * @param filterOpcionesPrePro OpcionesPrePro
	 * @param tableRequestDto TableRequestDto
	 * @param startsWith Boolean
	 * @return TableResponseDto<JerarquiaDto<OpcionesPrePro>>
	 */	
	public TableResponseDto<JerarquiaDto<OpcionesPrePro>> jerarquia(OpcionesPrePro filterOpcionesPrePro, TableRequestDto tableRequestDto, Boolean startsWith){
		List<JerarquiaDto<OpcionesPrePro>> listaOpcionesPrePro =  this.opcionesPreProDao.findAllLikeJerarquia(filterOpcionesPrePro, tableRequestDto);
		Long recordNum = this.opcionesPreProDao.findAllLikeCountJerarquia(filterOpcionesPrePro, tableRequestDto);
		return new TableResponseDto<JerarquiaDto<OpcionesPrePro>>(tableRequestDto, recordNum, listaOpcionesPrePro);
	}
	
	/**
	 * Finder method for siblings rows in the hierarchical the OpcionesPrePro table.
	 *
	 * @param filterOpcionesPrePro OpcionesPrePro
	 * @param tableRequestDto TableRequestDto
	 * @return TableResponseDto<JerarquiaDto<OpcionesPrePro>>
	 */	
	public TableResponseDto<JerarquiaDto<OpcionesPrePro>> jerarquiaChildren(OpcionesPrePro filterOpcionesPrePro, TableRequestDto tableRequestDto){
		TableResponseDto<JerarquiaDto<OpcionesPrePro>> tableResponseDto = new TableResponseDto<JerarquiaDto<OpcionesPrePro>>();
		tableResponseDto.addAdditionalParam(TableResponseDto.CHILDREN, this.opcionesPreProDao.findAllChild(filterOpcionesPrePro, tableRequestDto));
		return tableResponseDto;
	}
	
	/**
    * Exporta Datos al clipBoard
    *
    */
    public List<OpcionesPrePro> getMultiple(OpcionesPrePro filterOpcionesPrePro, TableRequestDto tableRequestDto,  Boolean startsWith){
		return this.opcionesPreProDao.getMultiple(filterOpcionesPrePro, tableRequestDto, startsWith);
	}

	@Override
	public void removeByPregunta(PreguntasProtocolo preguntaProtocolo) {
		this.opcionesPreProDao.removeByPregunta(preguntaProtocolo);		
	}
}

